import { ConfigurableModuleBuilder, Module, Inject, Head, HttpCode, Post, Res, Headers, Body, Controller, NotFoundException, InternalServerErrorException } from '@nestjs/common';
import { TriggerClient } from '@systemfsoftware/trigger.dev_sdk';

var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
function _ts_decorate(decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
}
__name(_ts_decorate, "_ts_decorate");
function _ts_metadata(k, v) {
  if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
    return Reflect.metadata(k, v);
}
__name(_ts_metadata, "_ts_metadata");
function _ts_param(paramIndex, decorator) {
  return function(target, key) {
    decorator(target, key, paramIndex);
  };
}
__name(_ts_param, "_ts_param");
var { ConfigurableModuleClass, MODULE_OPTIONS_TOKEN, OPTIONS_TYPE, ASYNC_OPTIONS_TYPE } = new ConfigurableModuleBuilder().build();
var TriggerClientRef = Symbol("TriggerClientRef");
var InjectTriggerDevClient = /* @__PURE__ */ __name((customProviderToken = TriggerClientRef) => Inject(customProviderToken), "InjectTriggerDevClient");
var _TriggerDevModule = class _TriggerDevModule extends ConfigurableModuleClass {
  /**
  * Register the instance for the TriggerDev client.
  *
  * Hint: If you want to have multiple instances of the client, you can use the `customProviderToken` to create multiple instances.
  *
  * @param options The options to use for the client
  * @param path The path to use for the controller (default: `/api/trigger`)
  * @param customProviderToken The token to use for the provider (default: {@link TriggerClientRef})
  */
  static register(options, path = "/api/trigger", customProviderToken = TriggerClientRef) {
    const { providers, ...rest } = ConfigurableModuleClass.register(options);
    const controller = createControllerByPath(customProviderToken, path);
    return {
      ...rest,
      controllers: [
        controller
      ],
      providers: [
        ...providers || [],
        {
          provide: customProviderToken,
          inject: [
            MODULE_OPTIONS_TOKEN
          ],
          useFactory: (options2) => {
            return new TriggerClient(options2);
          }
        }
      ],
      exports: [
        customProviderToken
      ]
    };
  }
  /**
  * Register the instance for the TriggerDev client asynchronously.
  *
  * Hint: If you want to have multiple instances of the client, you can use the `customProviderToken` to create multiple instances.
  *
  * @param options The options to use for the client
  * @param path The path to use for the controller (default: `/api/trigger`)
  * @param customProviderToken The token to use for the provider (default: {@link TriggerClientRef})
  */
  static registerAsync(options, path = "/api/trigger", customProviderToken = TriggerClientRef) {
    const { providers, ...rest } = ConfigurableModuleClass.registerAsync(options);
    const controller = createControllerByPath(customProviderToken, path);
    return {
      ...rest,
      controllers: [
        controller
      ],
      providers: [
        ...providers || [],
        {
          provide: customProviderToken,
          inject: [
            MODULE_OPTIONS_TOKEN
          ],
          useFactory: (options2) => {
            return new TriggerClient(options2);
          }
        }
      ],
      exports: [
        customProviderToken
      ]
    };
  }
};
__name(_TriggerDevModule, "TriggerDevModule");
var TriggerDevModule = _TriggerDevModule;
TriggerDevModule = _ts_decorate([
  Module({})
], TriggerDevModule);
function createControllerByPath(customProvider, path) {
  var _a;
  let TriggerDevController = (_a = class {
    constructor(client) {
      __publicField(this, "client");
      this.client = client;
    }
    empty() {
    }
    handleRequestPost(res, headers, body) {
      return this.handleRequest(res, "POST", headers, body);
    }
    /**
    * Forward the request to the TriggerDev client
    */
    async handleRequest(res, method, requestHeaders, requestBody) {
      const headers = {};
      Object.entries(requestHeaders || {}).forEach(([key, value]) => {
        headers[key] = value;
      });
      const standardRequest = new Request("https://nestjs.com/api/trigger", {
        headers,
        method,
        // @ts-ignore
        body: requestBody ? JSON.stringify(requestBody) : void 0
      });
      const response = await this.client.handleRequest(standardRequest);
      if (!response) {
        throw new NotFoundException({
          error: "Not found"
        });
      }
      if (isExpressResponse(res)) {
        res.status(response.status);
        if (response.headers) {
          res.set(response.headers);
        }
      } else if (isFastifyReply(res)) {
        res.code(response.status);
        if (response.headers) {
          res.headers(response.headers);
        }
      } else {
        throw new InternalServerErrorException("Unable to indetify the framework to set the status code, are you using Express or Fastify?");
      }
      return response.body;
    }
  }, __name(_a, "TriggerDevController"), _a);
  _ts_decorate([
    Head(),
    HttpCode(200),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", []),
    _ts_metadata("design:returntype", void 0)
  ], TriggerDevController.prototype, "empty", null);
  _ts_decorate([
    Post(),
    _ts_param(0, Res({
      passthrough: true
    })),
    _ts_param(1, Headers()),
    _ts_param(2, Body()),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [
      Object,
      Object,
      Object
    ]),
    _ts_metadata("design:returntype", typeof Promise === "undefined" ? Object : Promise)
  ], TriggerDevController.prototype, "handleRequestPost", null);
  TriggerDevController = _ts_decorate([
    Controller(path),
    _ts_param(0, InjectTriggerDevClient(customProvider)),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [
      typeof TriggerClient === "undefined" ? Object : TriggerClient
    ])
  ], TriggerDevController);
  return TriggerDevController;
}
__name(createControllerByPath, "createControllerByPath");
function isExpressResponse(res) {
  return typeof res?.status === "function" && typeof res?.render === "function";
}
__name(isExpressResponse, "isExpressResponse");
function isFastifyReply(res) {
  return typeof res?.code === "function" && typeof res?.headers === "function";
}
__name(isFastifyReply, "isFastifyReply");

export { InjectTriggerDevClient, TriggerClientRef, TriggerDevModule };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.mjs.map